/// <reference path="C:\Users\RUI\OneDrive\lib\aftereffects.d.ts\ae.d.ts"/>

(function () {
  const isCompActive = function (comp: CompItem): boolean {
    if (!(comp && comp instanceof CompItem)) {
      return false;
    } else {
      return true;
    }
  }

  const isLayerSelected = function (layers: Layer[]): boolean {
    if (layers.length === 0) {
      return false;
    } else {
      return true;
    }
  }

  const main = function (): number {
    const actComp: CompItem = <CompItem>app.project.activeItem;
    if (!isCompActive(actComp)) {
      return 0;
    }

    const selLayers: Layer[] = <Layer[]>actComp.selectedLayers;
    let soloValue = false;
    let sameAllValue = true;

    if (isLayerSelected(selLayers)) {
      soloValue = selLayers[selLayers.length - 1].solo;

      for (let i = 0; i < selLayers.length; i++) {
        if (selLayers[i].solo != soloValue) {
          sameAllValue = false;
          break;
        }
      }

      if (sameAllValue) {
        soloValue = !soloValue;
      }

      for (let i = 0; i < selLayers.length; i++) {
        selLayers[i].solo = soloValue;
      }
    } else {
      for (let i = 1; i <= actComp.layers.length; i++) {
        actComp.layer(i).solo = !actComp.layer(i).solo;
      }
    }

    return 0;
  }

  app.beginUndoGroup("Reverse Solo");
  main();
  app.endUndoGroup();

  return 0;
}).call(this);
